/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package filesender;

import java.io.*;
import java.net.Socket;
import java.net.SocketException;

/**
 * クライアントセッション
 * @author tondol
 */
public class ClientSession extends AbstractSession implements Runnable {
    
    /**
     * クライアントセッションを開始
     * @param host 接続先のホスト
     * @param port 接続先のポート
     * @throws java.lang.IOException
     */
    public ClientSession(String host, int port) throws IOException {
        socket = new Socket(host, port);
        // 入力ストリームの文字コードを自動認識させる
        reader = new BufferedReader(new InputStreamReader(socket.getInputStream(), "JISAUTODETECT"));
        writer = new PrintStream(socket.getOutputStream());
        thread = new Thread(this);
        thread.start();
    }
    
    /**
     * メッセージ読み込み
     */
    public void run() {
        try {
            while (socket != null) {
                String line = reader.readLine();
                if (line == null) throw new IOException();
                executeMessage(line);
            }
        } catch(SocketException e) { // 自分で切断した
            Main.window.putMessage("+socket closed");
        } catch(IOException e) { // 相手から切断された
            Main.window.putMessage("-connection refused");
        } finally {
            this.close();
            Main.window.setState(MainView.CLOSED);
        }
    }
    
    /**
     * セッションを終了
     * @throws java.lang.IOException
     */
    public void close() {
        try {
            if (writer != null) writer.flush();
            if (socket != null) socket.close();
            thread = null;
        } catch(IOException e) {
            ;
        }
    }
}
