/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package filesender;

import java.io.*;
import java.net.ServerSocket;
import java.net.SocketException;

/**
 * サーバーセッション
 * @author tondol
 */
public class ServerSession extends AbstractSession implements Runnable {
    private ServerSocket listen = null;
    
    /**
     * サーバーセッションを開始
     * @param port 待ち受けするポート
     * @throws java.lang.IOException
     */
    public ServerSession(int port) throws IOException {
        listen = new ServerSocket(port);
        thread = new Thread(this);
        thread.start();
    }
    
    /**
     * メッセージ読み込み
     */
    public void run() {
        try {
            // クライアント待ち受け
            socket = listen.accept();
            listen.close();
            // 入力ストリームの文字コードを自動認識させる
            reader = new BufferedReader(new InputStreamReader(socket.getInputStream(), "JISAUTODETECT"));
            writer = new PrintStream(socket.getOutputStream());
            // 状態を変更
            Main.window.setState(MainView.CONNECTED);
            Main.window.putMessage("+accepts client");
            // 読み込み開始
            while (socket != null) {
                String line = reader.readLine();
                if (line == null) throw new IOException();
                executeMessage(line);
            }
        } catch(SocketException e) { // 自分で切断した
            Main.window.putMessage("+socket closed");
        } catch(IOException e) { // 相手から切断された
            Main.window.putMessage("-connection refused");
        } finally {
            this.close();
            Main.window.setState(MainView.CLOSED);
        }
    }
    
    /**
     * サーバーセッションを終了
     * @throws java.lang.IOException
     */
    public void close() {
        try {
            if (listen != null) listen.close();
            if (writer != null) writer.flush();
            if (socket != null) socket.close();
            thread = null;
        } catch(IOException e) {
            ;
        }
    }
}
